package io.zipcoder.persistenceapp;

import com.apple.eawt.Application;
import org.h2.server.web.WebServlet;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.web.servlet.ServletRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.jdbc.core.JdbcTemplate;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

@SpringBootApplication
public class PersistenceStarterApplication implements CommandLineRunner  {

	private static final Logger log = LoggerFactory.getLogger(Application.class);


	public static void main(String[] args) {
		SpringApplication.run(PersistenceStarterApplication.class, args);
	}

	@Bean
	ServletRegistrationBean h2servletRegistration(){
		ServletRegistrationBean registrationBean = new ServletRegistrationBean( new WebServlet());
		registrationBean.addUrlMappings("/console/*");
		return registrationBean;
	}
     @Autowired

	 JdbcTemplate jdbcTemplate;

	@Override

	public void run(String... strings) throws Exception {
		log.info("Creating tables");
		jdbcTemplate.execute("DROP TABLE Person IF EXISTS");
		jdbcTemplate.execute("CREATE TABLE Person(" +
				"id Integer(10), first_name VARCHAR(255), last_name VARCHAR(255),Mobile VARCHAR(255),Birthday DATE,Home_Id SMALLINT(5)");

		jdbcTemplate.batchUpdate("INSERT INTO Person(id,first_name, last_name,Mobile,Birthday,Home_Id) VALUES ('1','hello','world','111-222-3333','01-2-1980','2')");
	    jdbcTemplate.batchUpdate("INSERT INTO Person(id,first_name, last_name,Mobile,Birthday,Home_Id) VALUES ('2','hai','world1','222-222-3333','02-3-1985','3')");
		jdbcTemplate.batchUpdate("INSERT INTO Person(id,first_name, last_name,Mobile,Birthday,Home_Id) VALUES ('3','welcome','world','333-222-3333','03-5-1989','4')");
		jdbcTemplate.batchUpdate("INSERT INTO Person(id,first_name, last_name,Mobile,Birthday,Home_Id) VALUES ('4','hai','','111-222-3333','01-2-1980','2')");

//		List<Object[]> splitUpNames = Arrays.asList("John Woo", "Jeff Dean", "Josh Bloch", "Josh Long").stream()
//				.map(name -> name.split(" "))
//				.collect(Collectors.toList());
		//jdbcTemplate.query("select * from Person where id='1'");
	}
}
