package io.zipcoder.persistenceapp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.net.URI;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

@RestController
public class PersonController  {

    @Autowired
    PersonRepository personRepository;

    @RequestMapping(value = "/person", method = RequestMethod.POST )

    public ResponseEntity<?> createPerson(@RequestBody PersonService p){

        URI newPollUri = ServletUriComponentsBuilder
                .fromCurrentRequest()
                .path("/{id}")
                .buildAndExpand(p.getID() )
                .toUri();
        return new ResponseEntity<> (null, HttpStatus.CREATED) ;

    }

    @RequestMapping(value = "/person{id}", method = RequestMethod.GET)

    public  ResponseEntity<?> getPerson(@PathVariable Integer id){

        PersonService person=personRepository.findOne(id);

        return new ResponseEntity<>(person ,HttpStatus.OK ) ;
    }

    @RequestMapping(value = "/person", method = RequestMethod.GET)

    public ResponseEntity<Iterable  <PersonService > >getPersonList( ){
        Iterable<PersonService> person = personRepository .findAll();

        Iterable<PersonService > personIterable = StreamSupport.stream(person .spliterator(),false)

                .collect(Collectors.toList() );
        return new ResponseEntity<>(personIterable  , HttpStatus.OK ) ;
    }

    @RequestMapping(value = "/person/{id}", method = RequestMethod.PUT)
    public  ResponseEntity<?> updatePerson(@RequestBody PersonService person,@PathVariable Integer id){
        PersonService  p=personRepository.save(person ) ;
        return new ResponseEntity<>(HttpStatus.OK);
    }
    @RequestMapping(value = "/person{id}", method = RequestMethod.DELETE )
    public void deletePerson( @PathVariable Integer id){
        personRepository .delete(id);

    }
}
